/*
 * Joey and its relative products are published under the terms
 * of the Apache Software License.
 */
package org.asyrinx.brownie.core.collection.matrix;

import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

/**
 * @author Akima
 */
public class HashMapMatrix extends AbstractMapMatrix {

	/**
	 * Constructor for MatrixMap.
	 */
	public HashMapMatrix() {
		super();
	}

	/**
	 */
	protected Map newBaseRowsMap() {
		return new HashMap();
	}

	/**
	 */
	protected Set newColKeySet() {
		return new HashSet();
	}

	/**
	 */
	protected Map newGetColResult() {
		return new HashMap();
	}

	/**
	 */
	protected Map newGetRowResult(Map source) {
		return new HashMap(source);
	}

	/**
	 */
	protected Set newRowKeySet(Set source) {
		return new HashSet(source);
	}

	/**
	 */
	protected Map newRowMap() {
		return new HashMap();
	}

}